%token PLUS
%token MINUS
%token LPAREN
%token RPAREN
%token <int> INT_LIT
%token EOF

%start <Expr.expr> prog

%%

prog:
  | e = expr; EOF { e }

expr:
  | c = INT_LIT { Expr.IntLit(c) }
  | e1 = expr; PLUS; c2 = INT_LIT { Expr.Plus(e1, Expr.IntLit(c2)) }
  | e1 = expr; PLUS; LPAREN; e2 = expr; RPAREN { Expr.Plus(e1, e2) }
  | e1 = expr; MINUS; c2 = INT_LIT { Expr.Minus(e1, Expr.IntLit(c2)) }
  | e1 = expr; MINUS; LPAREN; e2 = expr; RPAREN { Expr.Minus(e1, e2) }
  | LPAREN; e = expr; RPAREN { e }
  (* ^^^ What expressions look like, "on the wire" *)

(*

3 + (4 - 2)

e ::= c | e + e | e - e

e ::= c
    | e + c
    | e - c

*)
