%token PLUS
%token MINUS
%token LPAREN
%token RPAREN
%token <int> INT_LIT
%token EOF

%start <Expr.expr> prog

%%

prog:
  | e = expr; EOF { e }

expr:
  | e = expr0 { e }

expr0:
  | e1 = expr0; PLUS; e2 = expr1 { Expr.Plus(e1, e2) }
  | e1 = expr0; MINUS; e2 = expr1 { Expr.Minus(e1, e2) }
  | e = expr1 { e }

expr1:
  | c = INT_LIT { Expr.IntLit(c) }
  | LPAREN; e = expr; RPAREN { e }

(*

3 + (4 - 2)

e ::= c | e + e | e - e

e ::= c
    | e + c
    | e - c

*)
